Skip to main content

A range slider is a multi-thumb slider used to select a range between two numbers.

Loading...

Features

  • Fully managed keyboard navigation
  • Supports touch or click on track to update value
  • Supports Right-to-Left directionality
  • Supports horizontal and vertical orientations
  • Prevents text selection while dragging

Installation

Install the range slider package:

npm install @zag-js/slider @zag-js/solid # or yarn add @zag-js/slider @zag-js/solid

Anatomy

Check the slider anatomy and part names.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the range slider package:

import * as rangeSlider from "@zag-js/slider"

The range slider package exports two key functions:

  • machine - State machine logic.
  • connect - Maps machine state to JSX props and event handlers.

Pass a unique id to useMachine so generated element ids stay predictable.

Then use the framework integration helpers:

import * as slider from "@zag-js/slider" import { normalizeProps, useMachine } from "@zag-js/solid" import { createMemo, For, createUniqueId } from "solid-js" export function RangeSlider() { const service = useMachine(slider.machine, { id: createUniqueId(), name: "quantity", defaultValue: [10, 60], }) const api = createMemo(() => slider.connect(service, normalizeProps)) return ( <div {...api().getRootProps()}> <div {...api().getControlProps()}> <div {...api().getTrackProps()}> <div {...api().getRangeProps()} /> </div> <For each={api().value}> {(_, index) => ( <div {...api().getThumbProps({ index: index() })}> <input {...api().getHiddenInputProps({ index: index() })} /> </div> )} </For> </div> </div> ) }

Changing the orientation

By default, the slider is assumed to be horizontal. To change the orientation to vertical, set the orientation property in the machine's context to vertical.

In this mode, the slider will use the arrow up and down keys to increment/decrement its value.

Don't forget to change the styles of the vertical slider by specifying its height

const service = useMachine(rangeSlider.machine, { orientation: "vertical", })

Setting the initial value

const service = useMachine(rangeSlider.machine, { defaultValue: [30, 60], })

Controlled range value

Use value and onValueChange to control both thumb values externally.

const service = useMachine(rangeSlider.machine, { value, onValueChange(details) { setValue(details.value) }, })

Specifying the minimum and maximum

By default, the minimum is 0 and the maximum is 100. If that's not what you want, you can easily specify different bounds by changing the values of the min and/or max attributes.

For example, to ask the user for a value between -10 and 10, you can use:

const service = useMachine(rangeSlider.machine, { min: -10, max: 10, })

Setting the value's granularity

By default, the granularity, is 1, meaning that the value is always an integer. You can change the step attribute to control the granularity.

For example, If you need a value between 5 and 10, accurate to two decimal places, you should set the value of step to 0.01:

const service = useMachine(rangeSlider.machine, { min: 5, max: 10, step: 0.01, })

Listening for changes

When the slider value changes, the onValueChange and onValueChangeEnd callbacks are invoked. You can use this to setup custom behaviors in your app.

const service = useMachine(rangeSlider.machine, { onValueChange(details) { // details => { value: number[] } console.log("value changing to:", details.value) }, onValueChangeEnd(details) { // details => { value: number[] } console.log("value has changed to:", details.value) }, })

Listening for thumb focus changes

Use onFocusChange to track which thumb is currently focused.

const service = useMachine(rangeSlider.machine, { onFocusChange(details) { // details => { focusedIndex: number, value: number[] } console.log("focused thumb:", details.focusedIndex) }, })

Preventing thumb overlap

By default, the range slider thumbs are allowed to overlap when their values are equal. To prevent this, use the minStepsBetweenThumbs to avoid thumbs with equal values.

const service = useMachine(rangeSlider.machine, { minStepsBetweenThumbs: 1, })

Thumb collision behavior

Use thumbCollisionBehavior to control how thumbs behave on collision.

const service = useMachine(rangeSlider.machine, { defaultValue: [20, 80], thumbCollisionBehavior: "push", // "none" | "push" | "swap" })

Usage within forms

To use range slider in forms, set name and render api.getHiddenInputProps({ index }) for each thumb.

const service = useMachine(rangeSlider.machine, { name: "quantity", })

RTL Support

The slider has built-in support for RTL alignment and interaction. In the RTL mode, operations are performed from right to left, meaning, the left arrow key will increment and the right arrow key will decrement.

To enable RTL support, pass the dir: rtl context property

const service = useMachine(rangeSlider.machine, { dir: "rtl", })

While we take care of the interactions in RTL mode, you'll have to ensure you apply the correct CSS styles to flip the layout.

Styling guide

Each slider part includes a data-part attribute you can target in CSS.

Focused State

When the slider thumb is focused, the data-focus attribute is added to the root, control, thumb and label parts.

[data-part="root"][data-focus] { /* styles for root focus state */ } [data-part="thumb"]:focus { /* styles for thumb focus state */ } [data-part="control"][data-focus] { /* styles for control focus state */ } [data-part="track"][data-focus] { /* styles for track focus state */ } [data-part="range"][data-focus] { /* styles for range focus state */ }

Disabled State

When the slider is disabled, the data-disabled attribute is added to the root, label, control and thumb.

[data-part="root"][data-disabled] { /* styles for root disabled state */ } [data-part="label"][data-disabled] { /* styles for label disabled state */ } [data-part="control"][data-disabled] { /* styles for control disabled state */ } [data-part="value-text"][data-disabled] { /* styles for output disabled state */ } [data-part="thumb"][data-disabled] { /* styles for thumb disabled state */ } [data-part="range"][data-disabled] { /* styles for range disabled state */ }

Orientation

[data-part="root"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ } [data-part="thumb"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ } [data-part="track"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ }

Methods and Properties

Machine Context

The slider machine exposes the following context properties:

  • idsElementIds | undefinedThe ids of the elements in the slider. Useful for composition.
  • aria-labelstring[] | undefinedThe aria-label of each slider thumb. Useful for providing an accessible name to the slider
  • aria-labelledbystring[] | undefinedThe `id` of the elements that labels each slider thumb. Useful for providing an accessible name to the slider
  • namestring | undefinedThe name associated with each slider thumb (when used in a form)
  • formstring | undefinedThe associate form of the underlying input element.
  • valuenumber[] | undefinedThe controlled value of the slider
  • defaultValuenumber[] | undefinedThe initial value of the slider when rendered. Use when you don't need to control the value of the slider.
  • disabledboolean | undefinedWhether the slider is disabled
  • readOnlyboolean | undefinedWhether the slider is read-only
  • invalidboolean | undefinedWhether the slider is invalid
  • onValueChange((details: ValueChangeDetails) => void) | undefinedFunction invoked when the value of the slider changes
  • onValueChangeEnd((details: ValueChangeDetails) => void) | undefinedFunction invoked when the slider value change is done
  • onFocusChange((details: FocusChangeDetails) => void) | undefinedFunction invoked when the slider's focused index changes
  • getAriaValueText((details: ValueTextDetails) => string) | undefinedFunction that returns a human readable value for the slider thumb
  • minnumber | undefinedThe minimum value of the slider
  • maxnumber | undefinedThe maximum value of the slider
  • stepnumber | undefinedThe step value of the slider
  • minStepsBetweenThumbsnumber | undefinedThe minimum permitted steps between multiple thumbs. `minStepsBetweenThumbs` * `step` should reflect the gap between the thumbs. - `step: 1` and `minStepsBetweenThumbs: 10` => gap is `10` - `step: 10` and `minStepsBetweenThumbs: 2` => gap is `20`
  • orientation"vertical" | "horizontal" | undefinedThe orientation of the slider
  • origin"start" | "center" | "end" | undefinedThe origin of the slider range. The track is filled from the origin to the thumb for single values. - "start": Useful when the value represents an absolute value - "center": Useful when the value represents an offset (relative) - "end": Useful when the value represents an offset from the end
  • thumbAlignment"contain" | "center" | undefinedThe alignment of the slider thumb relative to the track - `center`: the thumb will extend beyond the bounds of the slider track. - `contain`: the thumb will be contained within the bounds of the track.
  • thumbSize{ width: number; height: number } | undefinedThe slider thumbs dimensions
  • thumbCollisionBehavior"none" | "push" | "swap" | undefinedControls how thumbs behave when they collide during pointer interactions. - `none` (default): Thumbs cannot move past each other; excess movement is ignored. - `push`: Thumbs push each other without restoring their previous positions when dragged back. - `swap`: Thumbs swap places when dragged past each other.
  • dir"ltr" | "rtl" | undefinedThe document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode(() => ShadowRoot | Document | Node) | undefinedA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.

Machine API

The slider api exposes the following methods:

  • valuenumber[]The value of the slider.
  • draggingbooleanWhether the slider is being dragged.
  • focusedbooleanWhether the slider is focused.
  • setValue(value: number[]) => voidFunction to set the value of the slider.
  • getThumbValue(index: number) => numberReturns the value of the thumb at the given index.
  • setThumbValue(index: number, value: number) => voidSets the value of the thumb at the given index.
  • getValuePercent(value: number) => numberReturns the percent of the thumb at the given index.
  • getPercentValue(percent: number) => numberReturns the value of the thumb at the given percent.
  • getThumbPercent(index: number) => numberReturns the percent of the thumb at the given index.
  • setThumbPercent(index: number, percent: number) => voidSets the percent of the thumb at the given index.
  • getThumbMin(index: number) => numberReturns the min value of the thumb at the given index.
  • getThumbMax(index: number) => numberReturns the max value of the thumb at the given index.
  • increment(index: number) => voidFunction to increment the value of the slider at the given index.
  • decrement(index: number) => voidFunction to decrement the value of the slider at the given index.
  • focusVoidFunctionFunction to focus the slider. This focuses the first thumb.

Data Attributes

Label
data-scope
slider
data-part
label
data-disabled
Present when disabled
data-orientation
The orientation of the label
data-invalid
Present when invalid
data-dragging
Present when in the dragging state
data-focus
Present when focused
Root
data-scope
slider
data-part
root
data-disabled
Present when disabled
data-orientation
The orientation of the slider
data-dragging
Present when in the dragging state
data-invalid
Present when invalid
data-focus
Present when focused
ValueText
data-scope
slider
data-part
value-text
data-disabled
Present when disabled
data-orientation
The orientation of the valuetext
data-invalid
Present when invalid
data-focus
Present when focused
Track
data-scope
slider
data-part
track
data-disabled
Present when disabled
data-invalid
Present when invalid
data-dragging
Present when in the dragging state
data-orientation
The orientation of the track
data-focus
Present when focused
Thumb
data-scope
slider
data-part
thumb
data-index
The index of the item
data-disabled
Present when disabled
data-orientation
The orientation of the thumb
data-focus
Present when focused
data-dragging
Present when in the dragging state
Range
data-scope
slider
data-part
range
data-dragging
Present when in the dragging state
data-focus
Present when focused
data-invalid
Present when invalid
data-disabled
Present when disabled
data-orientation
The orientation of the range
Control
data-scope
slider
data-part
control
data-dragging
Present when in the dragging state
data-disabled
Present when disabled
data-orientation
The orientation of the control
data-invalid
Present when invalid
data-focus
Present when focused
MarkerGroup
data-scope
slider
data-part
marker-group
data-orientation
The orientation of the markergroup
Marker
data-scope
slider
data-part
marker
data-orientation
The orientation of the marker
data-value
The value of the item
data-disabled
Present when disabled
DraggingIndicator
data-scope
slider
data-part
dragging-indicator
data-orientation
The orientation of the draggingindicator
data-state
"open" | "closed"

Accessibility

Adheres to the Slider WAI-ARIA design pattern.

Keyboard Interactions

  • ArrowRight
    Increments the focused thumb based on defined step
  • ArrowLeft
    Decrements the focused thumb based on defined step
  • ArrowUp
    Increases the focused thumb by the step amount.
  • ArrowDown
    Decreases the focused thumb by the step amount.
  • PageUp
    Increases the focused thumb value by a larger step
  • PageDown
    Decreases the focused thumb value by a larger step
  • Shift + ArrowUp
    Increases the focused thumb value by a larger step
  • Shift + ArrowDown
    Decreases the focused thumb value by a larger step
  • Home
    Sets the focused thumb value to its minimum.
  • End
    Sets the focused thumb value to its maximum.
Edit this page on GitHub

Skip to main content

A range slider is a multi-thumb slider used to select a range between two numbers.

Loading...

Features

  • Fully managed keyboard navigation
  • Supports touch or click on track to update value
  • Supports Right-to-Left directionality
  • Supports horizontal and vertical orientations
  • Prevents text selection while dragging

Installation

Install the range slider package:

npm install @zag-js/slider @zag-js/vue # or yarn add @zag-js/slider @zag-js/vue

Anatomy

Check the slider anatomy and part names.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the range slider package:

import * as rangeSlider from "@zag-js/slider"

The range slider package exports two key functions:

  • machine - State machine logic.
  • connect - Maps machine state to JSX props and event handlers.

Pass a unique id to useMachine so generated element ids stay predictable.

Then use the framework integration helpers:

<script setup> import * as slider from "@zag-js/slider" import { normalizeProps, useMachine } from "@zag-js/vue" import { computed } from "vue" const service = useMachine(slider.machine, { id: "1", name: "quantity", defaultValue: [10, 60], }) const api = computed(() => slider.connect(service, normalizeProps)) </script> <template> <div ref="ref" v-bind="api.getRootProps()"> <div v-bind="api.getControlProps()"> <div v-bind="api.getTrackProps()"> <div v-bind="api.getRangeProps()" /> </div> <div v-for="(_, index) in api.value" :key="index" v-bind="api.getThumbProps({ index })" > <input v-bind="api.getHiddenInputProps({ index })" /> </div> </div> </div> </template>

Changing the orientation

By default, the slider is assumed to be horizontal. To change the orientation to vertical, set the orientation property in the machine's context to vertical.

In this mode, the slider will use the arrow up and down keys to increment/decrement its value.

Don't forget to change the styles of the vertical slider by specifying its height

const service = useMachine(rangeSlider.machine, { orientation: "vertical", })

Setting the initial value

const service = useMachine(rangeSlider.machine, { defaultValue: [30, 60], })

Controlled range value

Use value and onValueChange to control both thumb values externally.

const service = useMachine(rangeSlider.machine, { value, onValueChange(details) { setValue(details.value) }, })

Specifying the minimum and maximum

By default, the minimum is 0 and the maximum is 100. If that's not what you want, you can easily specify different bounds by changing the values of the min and/or max attributes.

For example, to ask the user for a value between -10 and 10, you can use:

const service = useMachine(rangeSlider.machine, { min: -10, max: 10, })

Setting the value's granularity

By default, the granularity, is 1, meaning that the value is always an integer. You can change the step attribute to control the granularity.

For example, If you need a value between 5 and 10, accurate to two decimal places, you should set the value of step to 0.01:

const service = useMachine(rangeSlider.machine, { min: 5, max: 10, step: 0.01, })

Listening for changes

When the slider value changes, the onValueChange and onValueChangeEnd callbacks are invoked. You can use this to setup custom behaviors in your app.

const service = useMachine(rangeSlider.machine, { onValueChange(details) { // details => { value: number[] } console.log("value changing to:", details.value) }, onValueChangeEnd(details) { // details => { value: number[] } console.log("value has changed to:", details.value) }, })

Listening for thumb focus changes

Use onFocusChange to track which thumb is currently focused.

const service = useMachine(rangeSlider.machine, { onFocusChange(details) { // details => { focusedIndex: number, value: number[] } console.log("focused thumb:", details.focusedIndex) }, })

Preventing thumb overlap

By default, the range slider thumbs are allowed to overlap when their values are equal. To prevent this, use the minStepsBetweenThumbs to avoid thumbs with equal values.

const service = useMachine(rangeSlider.machine, { minStepsBetweenThumbs: 1, })

Thumb collision behavior

Use thumbCollisionBehavior to control how thumbs behave on collision.

const service = useMachine(rangeSlider.machine, { defaultValue: [20, 80], thumbCollisionBehavior: "push", // "none" | "push" | "swap" })

Usage within forms

To use range slider in forms, set name and render api.getHiddenInputProps({ index }) for each thumb.

const service = useMachine(rangeSlider.machine, { name: "quantity", })

RTL Support

The slider has built-in support for RTL alignment and interaction. In the RTL mode, operations are performed from right to left, meaning, the left arrow key will increment and the right arrow key will decrement.

To enable RTL support, pass the dir: rtl context property

const service = useMachine(rangeSlider.machine, { dir: "rtl", })

While we take care of the interactions in RTL mode, you'll have to ensure you apply the correct CSS styles to flip the layout.

Styling guide

Each slider part includes a data-part attribute you can target in CSS.

Focused State

When the slider thumb is focused, the data-focus attribute is added to the root, control, thumb and label parts.

[data-part="root"][data-focus] { /* styles for root focus state */ } [data-part="thumb"]:focus { /* styles for thumb focus state */ } [data-part="control"][data-focus] { /* styles for control focus state */ } [data-part="track"][data-focus] { /* styles for track focus state */ } [data-part="range"][data-focus] { /* styles for range focus state */ }

Disabled State

When the slider is disabled, the data-disabled attribute is added to the root, label, control and thumb.

[data-part="root"][data-disabled] { /* styles for root disabled state */ } [data-part="label"][data-disabled] { /* styles for label disabled state */ } [data-part="control"][data-disabled] { /* styles for control disabled state */ } [data-part="value-text"][data-disabled] { /* styles for output disabled state */ } [data-part="thumb"][data-disabled] { /* styles for thumb disabled state */ } [data-part="range"][data-disabled] { /* styles for range disabled state */ }

Orientation

[data-part="root"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ } [data-part="thumb"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ } [data-part="track"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ }

Methods and Properties

Machine Context

The slider machine exposes the following context properties:

  • idsElementIds | undefinedThe ids of the elements in the slider. Useful for composition.
  • aria-labelstring[] | undefinedThe aria-label of each slider thumb. Useful for providing an accessible name to the slider
  • aria-labelledbystring[] | undefinedThe `id` of the elements that labels each slider thumb. Useful for providing an accessible name to the slider
  • namestring | undefinedThe name associated with each slider thumb (when used in a form)
  • formstring | undefinedThe associate form of the underlying input element.
  • valuenumber[] | undefinedThe controlled value of the slider
  • defaultValuenumber[] | undefinedThe initial value of the slider when rendered. Use when you don't need to control the value of the slider.
  • disabledboolean | undefinedWhether the slider is disabled
  • readOnlyboolean | undefinedWhether the slider is read-only
  • invalidboolean | undefinedWhether the slider is invalid
  • onValueChange((details: ValueChangeDetails) => void) | undefinedFunction invoked when the value of the slider changes
  • onValueChangeEnd((details: ValueChangeDetails) => void) | undefinedFunction invoked when the slider value change is done
  • onFocusChange((details: FocusChangeDetails) => void) | undefinedFunction invoked when the slider's focused index changes
  • getAriaValueText((details: ValueTextDetails) => string) | undefinedFunction that returns a human readable value for the slider thumb
  • minnumber | undefinedThe minimum value of the slider
  • maxnumber | undefinedThe maximum value of the slider
  • stepnumber | undefinedThe step value of the slider
  • minStepsBetweenThumbsnumber | undefinedThe minimum permitted steps between multiple thumbs. `minStepsBetweenThumbs` * `step` should reflect the gap between the thumbs. - `step: 1` and `minStepsBetweenThumbs: 10` => gap is `10` - `step: 10` and `minStepsBetweenThumbs: 2` => gap is `20`
  • orientation"vertical" | "horizontal" | undefinedThe orientation of the slider
  • origin"start" | "center" | "end" | undefinedThe origin of the slider range. The track is filled from the origin to the thumb for single values. - "start": Useful when the value represents an absolute value - "center": Useful when the value represents an offset (relative) - "end": Useful when the value represents an offset from the end
  • thumbAlignment"contain" | "center" | undefinedThe alignment of the slider thumb relative to the track - `center`: the thumb will extend beyond the bounds of the slider track. - `contain`: the thumb will be contained within the bounds of the track.
  • thumbSize{ width: number; height: number } | undefinedThe slider thumbs dimensions
  • thumbCollisionBehavior"none" | "push" | "swap" | undefinedControls how thumbs behave when they collide during pointer interactions. - `none` (default): Thumbs cannot move past each other; excess movement is ignored. - `push`: Thumbs push each other without restoring their previous positions when dragged back. - `swap`: Thumbs swap places when dragged past each other.
  • dir"ltr" | "rtl" | undefinedThe document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode(() => ShadowRoot | Document | Node) | undefinedA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.

Machine API

The slider api exposes the following methods:

  • valuenumber[]The value of the slider.
  • draggingbooleanWhether the slider is being dragged.
  • focusedbooleanWhether the slider is focused.
  • setValue(value: number[]) => voidFunction to set the value of the slider.
  • getThumbValue(index: number) => numberReturns the value of the thumb at the given index.
  • setThumbValue(index: number, value: number) => voidSets the value of the thumb at the given index.
  • getValuePercent(value: number) => numberReturns the percent of the thumb at the given index.
  • getPercentValue(percent: number) => numberReturns the value of the thumb at the given percent.
  • getThumbPercent(index: number) => numberReturns the percent of the thumb at the given index.
  • setThumbPercent(index: number, percent: number) => voidSets the percent of the thumb at the given index.
  • getThumbMin(index: number) => numberReturns the min value of the thumb at the given index.
  • getThumbMax(index: number) => numberReturns the max value of the thumb at the given index.
  • increment(index: number) => voidFunction to increment the value of the slider at the given index.
  • decrement(index: number) => voidFunction to decrement the value of the slider at the given index.
  • focusVoidFunctionFunction to focus the slider. This focuses the first thumb.

Data Attributes

Label
data-scope
slider
data-part
label
data-disabled
Present when disabled
data-orientation
The orientation of the label
data-invalid
Present when invalid
data-dragging
Present when in the dragging state
data-focus
Present when focused
Root
data-scope
slider
data-part
root
data-disabled
Present when disabled
data-orientation
The orientation of the slider
data-dragging
Present when in the dragging state
data-invalid
Present when invalid
data-focus
Present when focused
ValueText
data-scope
slider
data-part
value-text
data-disabled
Present when disabled
data-orientation
The orientation of the valuetext
data-invalid
Present when invalid
data-focus
Present when focused
Track
data-scope
slider
data-part
track
data-disabled
Present when disabled
data-invalid
Present when invalid
data-dragging
Present when in the dragging state
data-orientation
The orientation of the track
data-focus
Present when focused
Thumb
data-scope
slider
data-part
thumb
data-index
The index of the item
data-disabled
Present when disabled
data-orientation
The orientation of the thumb
data-focus
Present when focused
data-dragging
Present when in the dragging state
Range
data-scope
slider
data-part
range
data-dragging
Present when in the dragging state
data-focus
Present when focused
data-invalid
Present when invalid
data-disabled
Present when disabled
data-orientation
The orientation of the range
Control
data-scope
slider
data-part
control
data-dragging
Present when in the dragging state
data-disabled
Present when disabled
data-orientation
The orientation of the control
data-invalid
Present when invalid
data-focus
Present when focused
MarkerGroup
data-scope
slider
data-part
marker-group
data-orientation
The orientation of the markergroup
Marker
data-scope
slider
data-part
marker
data-orientation
The orientation of the marker
data-value
The value of the item
data-disabled
Present when disabled
DraggingIndicator
data-scope
slider
data-part
dragging-indicator
data-orientation
The orientation of the draggingindicator
data-state
"open" | "closed"

Accessibility

Adheres to the Slider WAI-ARIA design pattern.

Keyboard Interactions

  • ArrowRight
    Increments the focused thumb based on defined step
  • ArrowLeft
    Decrements the focused thumb based on defined step
  • ArrowUp
    Increases the focused thumb by the step amount.
  • ArrowDown
    Decreases the focused thumb by the step amount.
  • PageUp
    Increases the focused thumb value by a larger step
  • PageDown
    Decreases the focused thumb value by a larger step
  • Shift + ArrowUp
    Increases the focused thumb value by a larger step
  • Shift + ArrowDown
    Decreases the focused thumb value by a larger step
  • Home
    Sets the focused thumb value to its minimum.
  • End
    Sets the focused thumb value to its maximum.
Edit this page on GitHub

Skip to main content

A range slider is a multi-thumb slider used to select a range between two numbers.

Loading...

Features

  • Fully managed keyboard navigation
  • Supports touch or click on track to update value
  • Supports Right-to-Left directionality
  • Supports horizontal and vertical orientations
  • Prevents text selection while dragging

Installation

Install the range slider package:

npm install @zag-js/slider @zag-js/react # or yarn add @zag-js/slider @zag-js/react

Anatomy

Check the slider anatomy and part names.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

Import the range slider package:

import * as rangeSlider from "@zag-js/slider"

The range slider package exports two key functions:

  • machine - State machine logic.
  • connect - Maps machine state to JSX props and event handlers.

Pass a unique id to useMachine so generated element ids stay predictable.

Then use the framework integration helpers:

import * as slider from "@zag-js/slider" import { useMachine, normalizeProps } from "@zag-js/react" import { useId } from "react" export function RangeSlider() { const service = useMachine(slider.machine, { id: useId(), name: "quantity", defaultValue: [10, 60], }) const api = slider.connect(service, normalizeProps) return ( <div {...api.getRootProps()}> <div {...api.getControlProps()}> <div {...api.getTrackProps()}> <div {...api.getRangeProps()} /> </div> {api.value.map((_, index) => ( <div key={index} {...api.getThumbProps({ index })}> <input {...api.getHiddenInputProps({ index })} /> </div> ))} </div> </div> ) }

Changing the orientation

By default, the slider is assumed to be horizontal. To change the orientation to vertical, set the orientation property in the machine's context to vertical.

In this mode, the slider will use the arrow up and down keys to increment/decrement its value.

Don't forget to change the styles of the vertical slider by specifying its height

const service = useMachine(rangeSlider.machine, { orientation: "vertical", })

Setting the initial value

const service = useMachine(rangeSlider.machine, { defaultValue: [30, 60], })

Controlled range value

Use value and onValueChange to control both thumb values externally.

const service = useMachine(rangeSlider.machine, { value, onValueChange(details) { setValue(details.value) }, })

Specifying the minimum and maximum

By default, the minimum is 0 and the maximum is 100. If that's not what you want, you can easily specify different bounds by changing the values of the min and/or max attributes.

For example, to ask the user for a value between -10 and 10, you can use:

const service = useMachine(rangeSlider.machine, { min: -10, max: 10, })

Setting the value's granularity

By default, the granularity, is 1, meaning that the value is always an integer. You can change the step attribute to control the granularity.

For example, If you need a value between 5 and 10, accurate to two decimal places, you should set the value of step to 0.01:

const service = useMachine(rangeSlider.machine, { min: 5, max: 10, step: 0.01, })

Listening for changes

When the slider value changes, the onValueChange and onValueChangeEnd callbacks are invoked. You can use this to setup custom behaviors in your app.

const service = useMachine(rangeSlider.machine, { onValueChange(details) { // details => { value: number[] } console.log("value changing to:", details.value) }, onValueChangeEnd(details) { // details => { value: number[] } console.log("value has changed to:", details.value) }, })

Listening for thumb focus changes

Use onFocusChange to track which thumb is currently focused.

const service = useMachine(rangeSlider.machine, { onFocusChange(details) { // details => { focusedIndex: number, value: number[] } console.log("focused thumb:", details.focusedIndex) }, })

Preventing thumb overlap

By default, the range slider thumbs are allowed to overlap when their values are equal. To prevent this, use the minStepsBetweenThumbs to avoid thumbs with equal values.

const service = useMachine(rangeSlider.machine, { minStepsBetweenThumbs: 1, })

Thumb collision behavior

Use thumbCollisionBehavior to control how thumbs behave on collision.

const service = useMachine(rangeSlider.machine, { defaultValue: [20, 80], thumbCollisionBehavior: "push", // "none" | "push" | "swap" })

Usage within forms

To use range slider in forms, set name and render api.getHiddenInputProps({ index }) for each thumb.

const service = useMachine(rangeSlider.machine, { name: "quantity", })

RTL Support

The slider has built-in support for RTL alignment and interaction. In the RTL mode, operations are performed from right to left, meaning, the left arrow key will increment and the right arrow key will decrement.

To enable RTL support, pass the dir: rtl context property

const service = useMachine(rangeSlider.machine, { dir: "rtl", })

While we take care of the interactions in RTL mode, you'll have to ensure you apply the correct CSS styles to flip the layout.

Styling guide

Each slider part includes a data-part attribute you can target in CSS.

Focused State

When the slider thumb is focused, the data-focus attribute is added to the root, control, thumb and label parts.

[data-part="root"][data-focus] { /* styles for root focus state */ } [data-part="thumb"]:focus { /* styles for thumb focus state */ } [data-part="control"][data-focus] { /* styles for control focus state */ } [data-part="track"][data-focus] { /* styles for track focus state */ } [data-part="range"][data-focus] { /* styles for range focus state */ }

Disabled State

When the slider is disabled, the data-disabled attribute is added to the root, label, control and thumb.

[data-part="root"][data-disabled] { /* styles for root disabled state */ } [data-part="label"][data-disabled] { /* styles for label disabled state */ } [data-part="control"][data-disabled] { /* styles for control disabled state */ } [data-part="value-text"][data-disabled] { /* styles for output disabled state */ } [data-part="thumb"][data-disabled] { /* styles for thumb disabled state */ } [data-part="range"][data-disabled] { /* styles for range disabled state */ }

Orientation

[data-part="root"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ } [data-part="thumb"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ } [data-part="track"][data-orientation="(horizontal|vertical)"] { /* styles for horizontal or vertical */ }

Methods and Properties

Machine Context

The slider machine exposes the following context properties:

  • idsElementIds | undefinedThe ids of the elements in the slider. Useful for composition.
  • aria-labelstring[] | undefinedThe aria-label of each slider thumb. Useful for providing an accessible name to the slider
  • aria-labelledbystring[] | undefinedThe `id` of the elements that labels each slider thumb. Useful for providing an accessible name to the slider
  • namestring | undefinedThe name associated with each slider thumb (when used in a form)
  • formstring | undefinedThe associate form of the underlying input element.
  • valuenumber[] | undefinedThe controlled value of the slider
  • defaultValuenumber[] | undefinedThe initial value of the slider when rendered. Use when you don't need to control the value of the slider.
  • disabledboolean | undefinedWhether the slider is disabled
  • readOnlyboolean | undefinedWhether the slider is read-only
  • invalidboolean | undefinedWhether the slider is invalid
  • onValueChange((details: ValueChangeDetails) => void) | undefinedFunction invoked when the value of the slider changes
  • onValueChangeEnd((details: ValueChangeDetails) => void) | undefinedFunction invoked when the slider value change is done
  • onFocusChange((details: FocusChangeDetails) => void) | undefinedFunction invoked when the slider's focused index changes
  • getAriaValueText((details: ValueTextDetails) => string) | undefinedFunction that returns a human readable value for the slider thumb
  • minnumber | undefinedThe minimum value of the slider
  • maxnumber | undefinedThe maximum value of the slider
  • stepnumber | undefinedThe step value of the slider
  • minStepsBetweenThumbsnumber | undefinedThe minimum permitted steps between multiple thumbs. `minStepsBetweenThumbs` * `step` should reflect the gap between the thumbs. - `step: 1` and `minStepsBetweenThumbs: 10` => gap is `10` - `step: 10` and `minStepsBetweenThumbs: 2` => gap is `20`
  • orientation"vertical" | "horizontal" | undefinedThe orientation of the slider
  • origin"start" | "center" | "end" | undefinedThe origin of the slider range. The track is filled from the origin to the thumb for single values. - "start": Useful when the value represents an absolute value - "center": Useful when the value represents an offset (relative) - "end": Useful when the value represents an offset from the end
  • thumbAlignment"contain" | "center" | undefinedThe alignment of the slider thumb relative to the track - `center`: the thumb will extend beyond the bounds of the slider track. - `contain`: the thumb will be contained within the bounds of the track.
  • thumbSize{ width: number; height: number } | undefinedThe slider thumbs dimensions
  • thumbCollisionBehavior"none" | "push" | "swap" | undefinedControls how thumbs behave when they collide during pointer interactions. - `none` (default): Thumbs cannot move past each other; excess movement is ignored. - `push`: Thumbs push each other without restoring their previous positions when dragged back. - `swap`: Thumbs swap places when dragged past each other.
  • dir"ltr" | "rtl" | undefinedThe document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode(() => ShadowRoot | Document | Node) | undefinedA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.

Machine API

The slider api exposes the following methods:

  • valuenumber[]The value of the slider.
  • draggingbooleanWhether the slider is being dragged.
  • focusedbooleanWhether the slider is focused.
  • setValue(value: number[]) => voidFunction to set the value of the slider.
  • getThumbValue(index: number) => numberReturns the value of the thumb at the given index.
  • setThumbValue(index: number, value: number) => voidSets the value of the thumb at the given index.
  • getValuePercent(value: number) => numberReturns the percent of the thumb at the given index.
  • getPercentValue(percent: number) => numberReturns the value of the thumb at the given percent.
  • getThumbPercent(index: number) => numberReturns the percent of the thumb at the given index.
  • setThumbPercent(index: number, percent: number) => voidSets the percent of the thumb at the given index.
  • getThumbMin(index: number) => numberReturns the min value of the thumb at the given index.
  • getThumbMax(index: number) => numberReturns the max value of the thumb at the given index.
  • increment(index: number) => voidFunction to increment the value of the slider at the given index.
  • decrement(index: number) => voidFunction to decrement the value of the slider at the given index.
  • focusVoidFunctionFunction to focus the slider. This focuses the first thumb.

Data Attributes

Label
data-scope
slider
data-part
label
data-disabled
Present when disabled
data-orientation
The orientation of the label
data-invalid
Present when invalid
data-dragging
Present when in the dragging state
data-focus
Present when focused
Root
data-scope
slider
data-part
root
data-disabled
Present when disabled
data-orientation
The orientation of the slider
data-dragging
Present when in the dragging state
data-invalid
Present when invalid
data-focus
Present when focused
ValueText
data-scope
slider
data-part
value-text
data-disabled
Present when disabled
data-orientation
The orientation of the valuetext
data-invalid
Present when invalid
data-focus
Present when focused
Track
data-scope
slider
data-part
track
data-disabled
Present when disabled
data-invalid
Present when invalid
data-dragging
Present when in the dragging state
data-orientation
The orientation of the track
data-focus
Present when focused
Thumb
data-scope
slider
data-part
thumb
data-index
The index of the item
data-disabled
Present when disabled
data-orientation
The orientation of the thumb
data-focus
Present when focused
data-dragging
Present when in the dragging state
Range
data-scope
slider
data-part
range
data-dragging
Present when in the dragging state
data-focus
Present when focused
data-invalid
Present when invalid
data-disabled
Present when disabled
data-orientation
The orientation of the range
Control
data-scope
slider
data-part
control
data-dragging
Present when in the dragging state
data-disabled
Present when disabled
data-orientation
The orientation of the control
data-invalid
Present when invalid
data-focus
Present when focused
MarkerGroup
data-scope
slider
data-part
marker-group
data-orientation
The orientation of the markergroup
Marker
data-scope
slider
data-part
marker
data-orientation
The orientation of the marker
data-value
The value of the item
data-disabled
Present when disabled
DraggingIndicator
data-scope
slider
data-part
dragging-indicator
data-orientation
The orientation of the draggingindicator
data-state
"open" | "closed"

Accessibility

Adheres to the Slider WAI-ARIA design pattern.

Keyboard Interactions

  • ArrowRight
    Increments the focused thumb based on defined step
  • ArrowLeft
    Decrements the focused thumb based on defined step
  • ArrowUp
    Increases the focused thumb by the step amount.
  • ArrowDown
    Decreases the focused thumb by the step amount.
  • PageUp
    Increases the focused thumb value by a larger step
  • PageDown
    Decreases the focused thumb value by a larger step
  • Shift + ArrowUp
    Increases the focused thumb value by a larger step
  • Shift + ArrowDown
    Decreases the focused thumb value by a larger step
  • Home
    Sets the focused thumb value to its minimum.
  • End
    Sets the focused thumb value to its maximum.
Edit this page on GitHub